/***************************************************************************
 *   Copyright (C) 2010 by Terraneo Federico                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   As a special exception, if other files instantiate templates or use   *
 *   macros or inline functions from this file, or you compile this file   *
 *   and link it with other works to produce a work based on this file,    *
 *   this file does not by itself cause the resulting work to be covered   *
 *   by the GNU General Public License. However the source code for this   *
 *   file must still be made available in accordance with the GNU General  *
 *   Public License. This exception does not invalidate any other reasons  *
 *   why a work based on this file might be covered by the GNU General     *
 *   Public License.                                                       *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, see <http://www.gnu.org/licenses/>   *
 ***************************************************************************/

#ifndef ARCH_REGISTERS_H
#define	ARCH_REGISTERS_H

/**
 * \addtogroup Interfaces
 * \{
 */

/**
 * \file arch_registers.h
 * This file should contain the list of hardware registers of the selected
 * architecture, to allow application to directly access the hardware.
 *
 * The list of these registers is usually provided by the chip vendor in the
 * form of one or more header files.
 *
 * To include these registers in a portable way, here we only include
 * arch_registers_impl.h, which will be an header file in
 * arch/arch name/board name/interfaces_impl
 *
 * The usual implementation of arch_registers_impl.h is simply to include
 * the header files provided by the chip vendor.
 */

/**
 * \}
 */

#include "boot/arch_registers_impl.h"

#endif //ARCH_REGISTERS_H
