/***************************************************************************
  *   Copyright (C) 2022 - 2023 by Federico Amedeo Izzo IU2NUO,            *
 *                                Niccolò Izzo IU2KIN                      *
 *                                Frederik Saraci IU2NRO                   *
 *                                Silvano Seva IU2KWO                      *
 *                                Joseph Stephen VK7JS                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, see <http://www.gnu.org/licenses/>   *
 ***************************************************************************/
#ifndef ENGLISHSTRINGS_H
#define ENGLISHSTRINGS_H

#include "ui/ui_strings.h"

const stringsTable_t englishStrings =
{
    .languageName      = "English",
    .off               = "OFF",
    .on                = "ON",
    .banks             = "Banks",
    .channels          = "Channels",
    .contacts          = "Contacts",
    .gps               = "GPS",
    .settings          = "Settings",
    .backupAndRestore  = "Backup & Restore",
    .info              = "Info",
    .about             = "About",
    .display           = "Display",
    .timeAndDate       = "Time & Date",
    .fm                = "FM",
    .m17               = "M17",
    .dmr               = "DMR",
    .defaultSettings   = "Default Settings",
    .brightness        = "Brightness",
    .contrast          = "Contrast",
    .timer             = "Timer",
    .gpsEnabled        = "GPS Enabled",
    .gpsSetTime        = "GPS Set Time",
    .UTCTimeZone       = "UTC Timezone",
    .voice             = "Voice",
    .level             = "Level",
    .phonetic          = "Phonetic",
    .beep              = "Beep",
    .backup            = "Backup",
    .restore           = "Restore",
    .batteryVoltage    = "Bat. Voltage",
    .batteryCharge     = "Bat. Charge",
    .RSSI              = "RSSI",
    .model             = "Model",
    .band              = "Band",
    .VHF               = "VHF",
    .UHF               = "UHF",
    .LCDType           = "LCD Type",
    .Niccolo           = "Niccolo' IU2KIN",
    .Silvano           = "Silvano IU2KWO",
    .Federico          = "Federico IU2NUO",
    .Fred              = "Fred IU2NRO",
    .Joseph            = "Joseph VK7JS",
    .allChannels       = "All channels",
    .menu              = "Menu",
    .gpsOff            = "GPS OFF",
    .noFix             = "No Fix",
    .fixLost           = "Fix Lost",
    .error             = "ERROR",
    .flashBackup       = "Flash Backup",
    .connectToRTXTool  = "Connect to RTXTool",
    .toBackupFlashAnd  = "to backup flash and",
    .pressPTTToStart   = "press PTT to start.",
    .flashRestore      = "Flash Restore",
    .toRestoreFlashAnd = "to restore flash and",
    .openRTX           = "OpenRTX",
    .gpsSettings       = "GPS Settings",
    .m17settings       = "M17 Settings",
    .callsign          = "Callsign:",
    .resetToDefaults   = "Reset to Defaults",
    .toReset           = "To reset:",
    .pressEnterTwice   = "Press Enter twice",
    .macroMenu         = "Macro Menu",
    .forEmergencyUse   = "For emergency use",
    .pressAnyButton    = "press any button.",
    .accessibility     = "Accessibility",
    .usedHeap          = "Used heap",
    .broadcast         = "ALL",
    .radioSettings     = "Radio Settings",
    .frequencyOffset   = "Frequency Offset"
};
#endif  // ENGLISHSTRINGS_H
